-------------------------------------------------------------
-- Jointures adaptatives en mode batch - SQL Server 2017 
-- DATAFLY - 202006
-------------------------------------------------------------
USE AdventureWorksBig
GO

-------------------------------------------------------------
-- SQL 2016 : pas de jointure adaptative, hash match
-------------------------------------------------------------
ALTER DATABASE AdventureWorksBig SET COMPATIBILITY_LEVEL = 130
SELECT compatibility_level FROM sys.databases WHERE name = 'AdventureWorksBig'
GO
ALTER DATABASE SCOPED CONFIGURATION CLEAR PROCEDURE_CACHE;  
SELECT ProductNumber,
       SUM(CAST(SOD.OrderQty AS BIGINT)) AS Quantity
FROM [AdventureWorksBig].[Sales].[SalesOrderDetailCSI] SOD   -- avec un index NCCSI
    JOIN dbo.ProductList P
        ON P.ProductID = SOD.ProductID
WHERE CarrierTrackingNumber = '17020' AND SOD.OrderQty < 2200  
GROUP BY ProductNumber
ORDER BY ProductNumber

-------------------------------------------------------------
-- Avec SQL Server 2017 : jointures adaptatives. Nested loop ou hash match
-------------------------------------------------------------
ALTER DATABASE AdventureWorksBig SET COMPATIBILITY_LEVEL = 140
SELECT compatibility_level FROM sys.databases WHERE name = 'AdventureWorksBig'
GO
ALTER DATABASE SCOPED CONFIGURATION CLEAR PROCEDURE_CACHE;  -- DBCC FREEPROCCACHE
SELECT ProductNumber,
       SUM(CAST(SOD.OrderQty AS BIGINT)) AS Quantity
FROM [AdventureWorksBig].[Sales].[SalesOrderDetailCSI] SOD   -- avec un index NCCSI 
    JOIN dbo.ProductList P
        ON P.ProductID = SOD.ProductID
WHERE CarrierTrackingNumber = '17020' AND SOD.OrderQty < 2200  -- ou 2500
GROUP BY ProductNumber
ORDER BY ProductNumber
--Dsactivation niveau requte
--OPTION (USE HINT('DISABLE_BATCH_MODE_ADAPTIVE_JOINS')); 

-------------------------------------------------------------
-- Dsactivation niveau base
-------------------------------------------------------------
-- SQL Server 2017
ALTER DATABASE SCOPED CONFIGURATION SET DISABLE_BATCH_MODE_ADAPTIVE_JOINS = ON;
-- SQL Server 2019
ALTER DATABASE SCOPED CONFIGURATION SET BATCH_MODE_ADAPTIVE_JOINS = OFF;
-- ou au niveau de la requte
