-------------------------------------------------------------
-- Excution entrelace - SQL Server 2017 
-- Compilation diffre de variable table - SQL Server 2019 
-- DATAFLY - 202006
-------------------------------------------------------------
USE AdventureWorksBig
GO

CREATE OR ALTER FUNCTION dbo.fn_MyTblFunc
(
    @SpecialOfferID INT
)
RETURNS @MyFilteredResults TABLE
(
    SalesOrderID INT NOT NULL,
    SalesOrderDetailID INT NOT NULL,
    OrderQty SMALLINT NOT NULL,
    UnitPriceDiscount MONEY NOT NULL,
    TotalDiscount MONEY NOT NULL
PRIMARY KEY (SalesOrderID, SalesOrderDetailID)
)
AS
BEGIN
    INSERT @MyFilteredResults
    SELECT SalesOrderID,
           SalesOrderDetailID,
           OrderQty,
           UnitPriceDiscount,
           (UnitPriceDiscount * OrderQty)
    FROM Sales.SalesOrderDetail
	WHERE SpecialOfferID = @SpecialOfferID
    RETURN;
END;
GO
--CREATE NONCLUSTERED INDEX IX_SpecialOfferID ON Sales.SalesOrderDetail(SpecialOfferID) INCLUDE (OrderQty, UnitPriceDiscount) 


SET STATISTICS TIME ON
-------------------------------------------------------------
-- SQL 2016 : cardinalit estime = 100 lignes
-------------------------------------------------------------
ALTER DATABASE AdventureWorksBig SET COMPATIBILITY_LEVEL = 130  -- ou pire 110 : 1 ligne
SELECT compatibility_level FROM sys.databases WHERE name = 'AdventureWorksBig'
GO
ALTER DATABASE SCOPED CONFIGURATION CLEAR PROCEDURE_CACHE;  -- DBCC FREEPROCCACHE
DBCC DROPCLEANBUFFERS
SELECT COUNT(*) FROM Sales.SalesOrderHeader SOH 
JOIN dbo.fn_MyTblFunc(12) AS FMTF
ON SOH.SalesOrderID = FMTF.SalesOrderID
GO
-------------------------------------------------------------
-- SQL 2017 : excution entrelace !
-------------------------------------------------------------
ALTER DATABASE AdventureWorksBig SET COMPATIBILITY_LEVEL = 140
SELECT compatibility_level FROM sys.databases WHERE name = 'AdventureWorksBig'
GO
ALTER DATABASE SCOPED CONFIGURATION CLEAR PROCEDURE_CACHE;  -- DBCC FREEPROCCACHE
DBCC DROPCLEANBUFFERS
SELECT COUNT(*) FROM Sales.SalesOrderHeader SOH 
JOIN dbo.fn_MyTblFunc(12) AS FMTF
ON SOH.SalesOrderID = FMTF.SalesOrderID
-- dsactivation
-- OPTION (USE HINT('DISABLE_INTERLEAVED_EXECUTION_TVF'));
GO

-- Dsactivation niveau base
-- SQL Server 2017
ALTER DATABASE SCOPED CONFIGURATION SET DISABLE_INTERLEAVED_EXECUTION_TVF = OFF;
-- SQL Server 2019
ALTER DATABASE SCOPED CONFIGURATION SET INTERLEAVED_EXECUTION_TVF = ON;

-------------------------------------------------------------
-- Compilation diffre de variable table - SQL Server 2019 
-------------------------------------------------------------
USE AdventureWorksBig
GO
SET STATISTICS TIME ON
-------------------------------------------------------------
-- SQL 2017 : cardinalit estime = 1 ligne
-------------------------------------------------------------
ALTER DATABASE AdventureWorksBig SET COMPATIBILITY_LEVEL = 140
SELECT compatibility_level FROM sys.databases WHERE name = 'AdventureWorksBig'
GO
DECLARE @MyTableVar TABLE
(
    SalesOrderID INT NOT NULL,
    SalesOrderDetailID INT NOT NULL,
    OrderQty SMALLINT NOT NULL,
    UnitPriceDiscount MONEY NOT NULL,
    TotalDiscount MONEY NOT NULL
        PRIMARY KEY (
                        SalesOrderID,
                        SalesOrderDetailID
                    )
);
INSERT @MyTableVar  --1113366lignes
SELECT SalesOrderID,
       SalesOrderDetailID,
       OrderQty,
       UnitPriceDiscount,
       (UnitPriceDiscount * OrderQty)
FROM Sales.SalesOrderDetail
WHERE SpecialOfferID = 12;
SELECT COUNT(*) FROM Sales.SalesOrderHeader SOH 
JOIN @MyTableVar AS MTV
ON SOH.SalesOrderID = MTV.SalesOrderID
GO
-------------------------------------------------------------
-- SQL 2019 : compilation diffre !
-------------------------------------------------------------
ALTER DATABASE AdventureWorksBig SET COMPATIBILITY_LEVEL = 150
SELECT compatibility_level FROM sys.databases WHERE name = 'AdventureWorksBig'
GO
ALTER DATABASE SCOPED CONFIGURATION CLEAR PROCEDURE_CACHE;  
DBCC DROPCLEANBUFFERS
DECLARE @MyTableVar TABLE
(
    SalesOrderID INT NOT NULL,
    SalesOrderDetailID INT NOT NULL,
    OrderQty SMALLINT NOT NULL,
    UnitPriceDiscount MONEY NOT NULL,
    TotalDiscount MONEY NOT NULL
        PRIMARY KEY (
                        SalesOrderID,
                        SalesOrderDetailID
                    )
);
INSERT @MyTableVar
SELECT SalesOrderID,
       SalesOrderDetailID,
       OrderQty,
       UnitPriceDiscount,
       (UnitPriceDiscount * OrderQty)
FROM Sales.SalesOrderDetail
WHERE SpecialOfferID = 12;
SELECT COUNT(*) FROM Sales.SalesOrderHeader SOH 
JOIN @MyTableVar AS MTV
ON SOH.SalesOrderID = MTV.SalesOrderID
--OPTION (MAXDOP 1)
--OPTION (USE HINT('DISABLE_DEFERRED_COMPILATION_TV'))
GO

-- Dsactivation
ALTER DATABASE SCOPED CONFIGURATION SET DEFERRED_COMPILATION_TV = OFF;